function X = compute_statematrix(u, y, esn, nmin)

% Si y est vide, on utilise cette fonction pour tester l'ESN; la sortie 
% renvoye dans l'ESN en feedback est donc celle calcule lors de la propagation 
% (uniquement prise en compte si des poids de rtroaction ont t donns)
% Si y est non vide, on l'utilise lors de la propagation : on appelle a 
% faire du teacherForcing (si les poids de rtroaction ne sont pas nuls...).

if isempty(y)
    teacherForcing = 0;
else
    teacherForcing = 1;
end

nmax = length(u(:,1));

%% Remplir la matrice X

X = zeros(nmax,esn.Nu + esn.Nx) ; 
Y = zeros(nmax,esn.Ny); % output either computed or y...
X(1,:) = [u(1,:), rand(1,esn.Nx)]; % starting state
if teacherForcing==1
    Y(1,:) = y(1,:);
else
    Y(1,:) = rand(1,esn.Ny);
end

for i = 2:nmax
    % input states
    X(i,1:esn.Nu) = u(i,:);  
    
    % internal states
    X(i,esn.Nu+1:esn.Nu+esn.Nx) = esn.leakage.*tanh(X(i,1:esn.Nu)*esn.Win'...
        + X(i-1,esn.Nu+1:esn.Nu+esn.Nx)*esn.W' + Y(i-1,:)*esn.Wfb')...
        +(1-esn.leakage).*X(1,esn.Nu+1:esn.Nu+esn.Nx);
 
    % output
    if teacherForcing==1
        Y(i,:) = y(i,:);
    else    
        Y(i,:) = tanh(X(i,:)*esn.Wout');
    end
end

X = X(nmin:nmax,:); 

end
