clear all; 
close all;

%% Gnrer les donnes d'apprentissage et de test

nmax = 400;

outMinPeriod = 4 ; outMaxPeriod = 16; % output period length range

uapp = ones(nmax,2);
u = ones(nmax,2);
currentValue1 = rand;
currentValue2 = rand;
for i = 1:nmax
    if rand < 0.015
        currentValue1 = rand;
    end
    if rand < 0.015
        currentValue2 = rand;
    end
    uapp(i,2) = 1 / (currentValue1 * (outMaxPeriod - outMinPeriod) + outMinPeriod);
    u(i,2) = 1/ (currentValue2 * (outMaxPeriod - outMinPeriod) + outMinPeriod);
end

yapp = zeros(nmax,1);
y = zeros(nmax,1);
Arg1 = rand;
Arg2 = rand;
for i = 1:nmax
    Arg1 = Arg1 + 2*pi/uapp(i,2);
    yapp(i,1) = sin(Arg1);
    Arg2 = Arg2 + 2*pi/u(i,2);
    y(i,1) = sin(Arg2);
end

figure(4); clf;
plot(uapp(:,2));
figure(5); clf;
plot(yapp(:,1));

%%%% Quelques paramtres intressants
Nu = 2; 
Nx = 200; 
Ny = 1; 
nmin = 200 ; % attendre l'tat d'cho
nPoints = nmax - nmin; % nombre de points restants



%% 1. Gnrer l'ESN

esn = generate_esn(Nu, Nx, Ny);

% Vous devrez ajuster ici quelques paramtres de l'ESN
% tels que esn.Wfb...




%% 2. Entraner l'ESN

[trainedEsn X] = train_esn(uapp, yapp, esn, nmin) ; 

% on trace l'volution de quatre tats
plot_states(X, [2 3 4 5], nPoints, 1) ; 

% Il vous reste  calculer ici le signal de sortie ytrain appris  partir de X



% puis  calculer l'erreur d'apprentissage



% on trace sur le mme graphe le signal yapp et le signal appris ytrain
plot_sequence(yapp(nmin:end,:), ytrain, nPoints,...
    'training: teacher sequence (red) vs predicted sequence (blue)');


%% 3. Tester l'ESN

ytest = test_esn(u, trainedEsn, nmin);

% Il vous reste  calculer l'erreur de test



% on trace sur le mme graphe le signal y et le signal appris ytest
plot_sequence(y(nmin:end,:), ytest, nPoints, ...
    'testing: teacher sequence (red) vs predicted sequence (blue)') ;




%% 4. Observer la valeur moyenne des poids de Wout

fprintf('average absolute output weights: %g\n', mean(abs(trainedEsn.Wout)));



