function esn = generate_esn(Nu, Nx, Ny)

%% Gnrer un ESN sous la forme d'une structure comprenant les paramtres
% les paramtres de taille Nx, Nu, Ny
% les matrices de paramtres Win, W, Wfb, Wout
% un paramtre de fuite : leakage
% un paramtre de rgularisation : lambda

% Paramtres de taille
esn.Nx = Nx; 
esn.Nu = Nu; 
esn.Ny = Ny; 
  
% Pour gnrer W, utiliser la densit suivante :
connectivity = min([10/Nx 1]);

W = sprand(Nx, Nx, connectivity);
W(W ~= 0) = 2*(W(W ~= 0) - 0.5);
v = 2 * abs(eigs(W, 1, 'lm'));
esn.W = 1/v .* W;
esn.Win = (rand(Nx, Nu) .- 0.5) .* 2;
esn.Wout = zeros(Ny, Nu + Nx);
esn.Wfb = zeros(Nx, Ny);
esn.leakage = 1;
esn.lambda = 0;

end