function plot_states(stateMatrix, states, nPoints, figNr)

if isempty(figNr)    
    nFigure = figure ;
else
    nFigure = figNr;
end

figure(figNr); clf;

if (nargin < 3)
    nPoints = length(stateMatrix(:,1)) ; 
end

nStates = length(states) ; 

xMax = ceil(sqrt(nStates)) ; 
yMax = ceil(nStates /xMax);

for iPlot = 1 : nStates
    subplot(xMax,yMax,iPlot) ; 
    plot(stateMatrix(1:nPoints, states(1,iPlot)))
end

