#use "datalib.ml" 

let data2 = Data.load "data2K.txt" float_of_string;;
let data3 = Data.load "data3K.txt" float_of_string;;
let iris = Data.load "iris.txt" (function 
  | "Iris-setosa" -> 1
  | "Iris-versicolor"-> 2
  | "Iris-virginica"-> 3 
  | x -> print_endline x;0);;

Data.image data2;;
Data.image data3;;
Data.image iris;;

Data.draw data2 (function 1.0-> Graphics.red | 2.0-> Graphics.green | 3.0-> Graphics.blue | _->0);;
Data.draw data3 (function 1.0-> Graphics.red | 2.0-> Graphics.green | 3.0-> Graphics.blue | _->0);;
Data.draw ~d1:0 ~d2:1 iris (function 1-> Graphics.red | 2-> Graphics.green | 3-> Graphics.blue | _->0);;
Data.draw ~d1:2 ~d2:3 iris (function 1-> Graphics.red | 2-> Graphics.green | 3-> Graphics.blue | _->0);;

Graphics.clear_graph ();;
Graphics.set_color Graphics.black;;

open DecisionTree

let tree_ex = Node(
  Node(Leaf("A"),1,1.0,Leaf("B")),
  0,2.0,
  Node(
    Node(Leaf("C"),0,4.0,Leaf("D")),
    1,2.0,Leaf("E")));;

draw1 (Graphics.draw_string) tree_ex;;

Graphics.clear_graph ();;

draw2 (fun (x1,x2,y1,y2) l -> Graphics.moveto ((x1+x2)/2) ((y1+y2)/2); Graphics.draw_string l)
  (0.0,6.0,0.0,4.0)
  tree_ex


